//
// ClpCom
// Nbv{[hLANL\tgEFA
//
// Copyright 2009 509(http://page.freett.com/509/)
//

// ----------------------------------------------------------------------------
// CũNw
// ----------------------------------------------------------------------------
#pragma comment(lib, "wsock32.lib")

// ----------------------------------------------------------------------------
// wb_t@C
// ----------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <winsock.h>

#include <deque>

#include "dmsg.h"	// fobOO
#include "tcpip_comm.h"	// TCP/IPR~jP[V
#include "config.h"	// ݒ

// ----------------------------------------------------------------------------
// }N
// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
// O[oϐ
// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
// t@C[Jϐ
// ----------------------------------------------------------------------------

// IPAhẌꗗ
std::deque<struct in_addr> l_deque_self_ip;

// pPbgM̃R[obN֐̃AhX  σ`FbNp
static void (*l_pCallBackFunc)(char*) = NULL;

// WSAAsyncSelect̃bZ[WM
static HWND l_hWnd_for_WSAAsyncSelect;

static int l_socket = INVALID_SOCKET;

static int l_packet_size = 1000;

struct comm_packet {
	union {
		unsigned char uc[4];
		struct {
			unsigned char	id[PASSWORD_MAX_LEN];
			unsigned short	len;
			unsigned char	padding1[2];
			unsigned int	error_detection;
			unsigned char	text[1];
		} s;
	} u;
};
struct comm_packet *l_recv_packet = NULL;
struct comm_packet *l_send_packet = NULL;

// ----------------------------------------------------------------------------
// WinSock̏
// ----------------------------------------------------------------------------
int init_winsock (void (*pCallBackFunc)(char*))
{
	WORD wVersionRequested;
	int  nErrorStatus;
	WSADATA wsaData;
	char hostname[256];	// ő255 RFC1123
	struct hostent *hostent_ptr;
	int i;
	struct in_addr ia;

	dmsg ("init_winsock: called\n");

	if (l_pCallBackFunc) {
		// ɏ
		return -1;
	}

	wVersionRequested = MAKEWORD(1, 1);
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
	if(nErrorStatus) {
		dmsg ("init_winsock: WSAStartup failed\n");
		return -1;
	}

	if(atexit((void (*)(void))(WSACleanup))) {
		dmsg ("init_winsock: atexit failed\n");
		return -1;
	}

	if (gethostname (hostname, 255)) {
		dmsg ("init_winsock: gethostname failed\n");
		return -1;
	}

	hostent_ptr = gethostbyname (hostname);
	if (hostent_ptr == NULL) {
		dmsg ("init_winsock: gethostbyname(%s) failed\n", hostname);
		return -1;
	}

	if (hostent_ptr->h_addrtype != AF_INET) {
		dmsg ("init_winsock: h_addrtype != AF_INET\n");
		return -1;
	}

	l_deque_self_ip.clear();
	for (i = 0; hostent_ptr->h_addr_list[i]; i++) {
		memcpy ((void*)&ia, hostent_ptr->h_addr_list[i], sizeof(ia));
		dmsg ("init_winsock: address %u.%u.%u.%u\n", 
			ia.S_un.S_un_b.s_b1,
			ia.S_un.S_un_b.s_b2,
			ia.S_un.S_un_b.s_b3,
			ia.S_un.S_un_b.s_b4);
		l_deque_self_ip.push_back(ia);
	}

	l_pCallBackFunc = pCallBackFunc;

	return 0;
}

// ----------------------------------------------------------------------------
// \Pbg
// ----------------------------------------------------------------------------
static void l_close_winsock (void)
{
	dmsg ("l_close_winsock: called\n");

	// Mobt@̉
	if (l_recv_packet) {
		free((void*)l_recv_packet);
	}

	// Mobt@̉
	if (l_send_packet) {
		free((void*)l_send_packet);
	}

	// \Pbg
	if (l_socket != INVALID_SOCKET) {
		closesocket(l_socket);
	}

	l_recv_packet = NULL;
	l_send_packet = NULL;
	l_socket = INVALID_SOCKET;
}

// ----------------------------------------------------------------------------
// \PbgJ
// ----------------------------------------------------------------------------
int open_winsock (HWND hWnd)
{
	struct sockaddr_in sa;
	BOOL sockopt;

	dmsg ("open_winsock: called\n");
	if (l_socket != INVALID_SOCKET) {
		// Ƀ\PbgĂ̂ŁAU
		l_close_winsock ();
	}
	if (hWnd == NULL) {
		// WSAAsyncSelect̃bZ[WM悪w肳ĂȂ
		dmsg ("open_winsock: invalid parameter; hWnd == NULL\n");
		return -1;
	}

	l_packet_size = CNF_NUM_ClpTextLen + sizeof (struct comm_packet);

	l_recv_packet = (struct comm_packet *)malloc(l_packet_size);
	if (l_recv_packet == NULL) {
		MessageBox(NULL, "Mpmۂł܂", "Error", MB_OK | MB_ICONINFORMATION);
		l_close_winsock ();
		return -1;
	}

	l_send_packet = (struct comm_packet *)malloc(l_packet_size);
	if (l_send_packet == NULL) {
		MessageBox(NULL, "Mpmۂł܂", "Error", MB_OK | MB_ICONINFORMATION);
		l_close_winsock ();
		return -1;
	}

	memset ((void*)l_recv_packet, (int)0, l_packet_size);
	memset ((void*)l_send_packet, (int)0, l_packet_size);

	l_hWnd_for_WSAAsyncSelect = hWnd;

	l_socket = socket(PF_INET, SOCK_DGRAM, 0);
	if(l_socket == INVALID_SOCKET){
		dmsg ("open_winsock: socket failed\n");
		return -1;
	}

	if(WSAAsyncSelect(l_socket, hWnd, WM_SOCK_ASYNC_EVENT, FD_READ) == SOCKET_ERROR) {
		dmsg ("open_winsock: WSAAsyncSelect failed\n");
		int errcode = WSAGetLastError ();
		dmsg ("open_winsock WSAAsyncSelect errcode=%d\n", errcode);
		l_close_winsock ();
		return -1;
	}

	sockopt = 1;
	setsockopt(l_socket, SOL_SOCKET, SO_REUSEADDR, (const char *)&sockopt, sizeof(sockopt));
	sockopt = 1;
	setsockopt(l_socket, SOL_SOCKET, SO_BROADCAST, (const char *)&sockopt, sizeof(sockopt));

	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = 0;
	sa.sin_port = htons(CNF_NUM_TcpipPort);
	memset(sa.sin_zero,(int)0,sizeof(sa.sin_zero));
	if(bind(l_socket,(const struct sockaddr *)&sa,sizeof(sa)) == SOCKET_ERROR) {
		dmsg ("open_winsock: bind failed\n");
		l_close_winsock ();
		return -1;
	}

	// I
	return 0;
}

// ----------------------------------------------------------------------------
// pPbgM
// ----------------------------------------------------------------------------
static void l_recv_winsock (void)
{
	int	ret;
	struct sockaddr_in sa;
	int	sa_len;
	int i;

	dmsg ("l_recv_winsock: called\n");
	if (l_socket == INVALID_SOCKET) {
		// \Pbg͊JĂȂ
		// ُȏԂȂ̂ŁAU
		l_close_winsock ();
		open_winsock (l_hWnd_for_WSAAsyncSelect);
		return;
	}

	sa_len = sizeof(sa);
	ret = recvfrom (l_socket, (char *)l_recv_packet, l_packet_size, 0, (struct sockaddr *)&sa, &sa_len);

	dmsg ("l_recv_winsock: recvfrom ret=%d\n", ret);
	if (ret == SOCKET_ERROR) {
		int errcode = WSAGetLastError ();
		dmsg ("l_recv_winsock: recvfrom errcode=%d\n", errcode);
		l_close_winsock ();
		open_winsock (l_hWnd_for_WSAAsyncSelect);
		return;
	}
	else if (ret == 0) {
		l_close_winsock ();
		open_winsock (l_hWnd_for_WSAAsyncSelect);
		return;
	}

	// ɎM
	dmsg ("l_recv_winsock: recvfrom peer %u.%u.%u.%u %u\n",
		sa.sin_addr.S_un.S_un_b.s_b1,
		sa.sin_addr.S_un.S_un_b.s_b2,
		sa.sin_addr.S_un.S_un_b.s_b3,
		sa.sin_addr.S_un.S_un_b.s_b4,
		ntohs(sa.sin_port)
	);
	
	// IPAhX瑗M͖̂
	for (i = 0; i < l_deque_self_ip.size(); i++) {
		if (!memcmp (&sa.sin_addr, &l_deque_self_ip[i], sizeof(struct in_addr))) {
			dmsg("l_recv_winsock: IPAhX瑗M\n");
			return;
		}
	}

	// MpPbg̃`FbN
	if (memcmp(l_recv_packet->u.s.id, CNF_STR_PassWord, PASSWORD_MAX_LEN)) {
		dmsg ("MΏۊÕpPbg\n");
		return;
	}
	if (l_recv_packet->u.s.error_detection != 0) {
		dmsg ("sȃpPbg(error_detection)\n");
		return;
	}
	if (l_recv_packet->u.s.len > (l_packet_size - sizeof(struct comm_packet))) {
		l_recv_packet->u.s.len = l_packet_size - sizeof(struct comm_packet);
		dmsg ("pPbĝŌ㔼Jbg\n");
	}

	if (l_pCallBackFunc) {
		l_recv_packet->u.s.text[l_recv_packet->u.s.len] = '\0';	// I[ۏႷ
		l_pCallBackFunc ((char*)l_recv_packet->u.s.text);
	}

}

// ----------------------------------------------------------------------------
// pPbgM
// ----------------------------------------------------------------------------
static void l_send_winsock (char *pText)
{
	int	ret;
	struct sockaddr_in sa;

	dmsg ("l_send_winsock: called\n");
	if (l_socket == INVALID_SOCKET) {
		// \Pbg͊JĂȂ
		if (open_winsock (l_hWnd_for_WSAAsyncSelect)) {
			// \PbgJȂ
			return;
		}
	}

	// MpPbg̍쐬
	memset ((void*)(l_send_packet->u.s.id), (int)0, sizeof(l_send_packet->u.s.id));
	memcpy ((void*)(l_send_packet->u.s.id), CNF_STR_PassWord, PASSWORD_MAX_LEN);
	l_send_packet->u.s.error_detection = 0;
	strncpy((char*)(l_send_packet->u.s.text), pText, l_packet_size - sizeof(struct comm_packet));
	l_send_packet->u.s.text[l_packet_size - sizeof(struct comm_packet)] = '\0';	// I[ۏႷ
	l_send_packet->u.s.len = strlen((const char *)(l_send_packet->u.s.text));

	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = 0xffffffff;	// RFC919 broadcast on a local hardware network, which must not be forwarded
	sa.sin_port = htons(CNF_NUM_TcpipPort);
	memset(sa.sin_zero,(int)0,sizeof(sa.sin_zero));
	ret = sendto (l_socket, (char *)l_send_packet, l_send_packet->u.s.len + sizeof(struct comm_packet), 0, (struct sockaddr *)&sa, sizeof(sa));

	dmsg ("l_send_winsock sendto ret=%d\n", ret);
	if (ret == SOCKET_ERROR) {
		int errcode = WSAGetLastError ();
		dmsg ("l_send_winsock sendto errcode=%d\n", errcode);
		l_close_winsock ();
		open_winsock (l_hWnd_for_WSAAsyncSelect);
	}

}

// ----------------------------------------------------------------------------
// 񓯊Cxg̏
// ----------------------------------------------------------------------------
void async_event_winsock (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	dmsg ("async_event_winsock: called\n");
	if (l_socket == INVALID_SOCKET) {
		// \Pbg͊JĂȂ
		if (open_winsock (l_hWnd_for_WSAAsyncSelect)) {
			// \PbgJȂ
			return;
		}
	}

	if(WSAGETSELECTERROR(lParam)) {
		// \PbgG[
		dmsg ("async_event_winsock: WSAGETSELECTERROR say error\n");
		l_close_winsock ();
		open_winsock (l_hWnd_for_WSAAsyncSelect);
		return;
	}

	if(l_socket != (int)wParam) {
		// ΏۊÕ\Pbg
		return;
	}

	switch(WSAGETSELECTEVENT(lParam)) {
	case FD_READ:
		l_recv_winsock ();
		break;
	default:
		break;
	}

	return;
}

// ----------------------------------------------------------------------------
// Nbv{[hXVɌĂ΂֐
// ----------------------------------------------------------------------------
int update_clip_board (char *pText)
{
	dmsg ("update_clip_board: called\n");
	if (l_socket == INVALID_SOCKET) {
		// \Pbg͊JĂȂ
		if (open_winsock (l_hWnd_for_WSAAsyncSelect)) {
			// \PbgJȂ
			return -1;
		}
	}

	l_send_winsock (pText);

	return 0;
}




